var PublicationsDrawer = React.createClass({
	getInitialState: function() {
		return {
			data:[],
		};
	},
	componentDidMount: function() {
		var self = this;
		$.ajax({
		    url: this.props.source,
		    type: 'get',
		    error: function(XMLHttpRequest, textStatus, errorThrown){
		        window.location.href = "/404.html";
		    }.bind(this),
		    success: function(response){
		    	if (this.isMounted()) {
					this.setState({
						data: response
					});
				}

		    document.title = "Websec México: " + response.title;
		    document.description = "Websec México: " + response.extract;

		    }.bind(this)

		});
	},
	render:function() {
		var items = this.state.data || {};
		return (
			<div className="">
		    	<PublicationsList items={items} />
		    	<NextPageDrawer term={this.props.term} category={this.props.category} page={this.props.page} />
		    </div>
			)
	}
});


var PublicationsList = React.createClass({
	render:function() {
		return (			
			<div className="">
				<h3>&nbsp;</h3>
				
				{this.props.items.map(function(item) {
					return <PublicationItemWrapper key={item.title} tags={item.tags} slug={item.slug} name={item.title} content={item.extract} created={item.created} category={item.category}/>;
				})}
			</div>
			)
	}
});

var PublicationItemWrapper = React.createClass({
	render:function() {
		var cleanExtract = this.props.content.replace(/(<([^>]+)>)/ig,"");
		return (
			<div className="blogs-item">
				<h4><a href={"/publicacion/" + this.props.category + "/" + this.props.slug} title={this.props.name}>{this.props.name}</a></h4>
				<p><i className="fa fa-calendar"></i> Publicado el {this.props.created}</p>
	          	<p>{cleanExtract}</p>
	          	<p><a className="btn btn-primary btn-sm" href={"/publicacion/" + this.props.category + "/" + this.props.slug} role="button">Leer más &raquo;</a></p>
		    	<div className="tags">
		    		<div><i className="fa fa-tags"></i> Etiquetado en:
		    			<div className="tagCloud">
		    			{(this.props.tags || []).map(function(tag) {
		    				return <TagsDrawer key={tag.slug} name={tag.name} slug={tag.slug} />
		    			})}
		    			</div>
		    		</div>
		    	</div>
		    	<hr/>
          	</div>
			)
	}
});

var NextPageDrawer = React.createClass({
	render:function() {

		var search = "";
		if(this.props.term.length > 0) { 
			search = "/" + this.props.term;
		}

		return (
			<div>
				<a className="btn btn-lg btn-primary" href={"/publicaciones/" + this.props.category + "/" + this.props.page + search} title="Siguiente página" >Siguiente página</a>
          	</div>
			)
	}
});

var TagsDrawer = React.createClass({
	render:function(){
		return(
			<a href={"/publicaciones/" + this.props.slug} className="" title={this.props.name}>{this.props.name}</a>
			)
	}
});

var params = window.location.pathname.split('/').slice(1);
var page = 1;
var query = "";
var term = "";

if(typeof params[2] != 'undefined')
	page = parseInt(params[2]);

if(typeof params[3] != 'undefined') {
	query = "/api/publication/search?query=" + params[3] + "&page="+ page;
	term = params[3];
} else {
	query = "/api/publication/extracts?category=" + params[1] + "&page="+ page;
} 

page++;

ReactDOM.render(<PublicationsDrawer term={term} page={page} category={params[1]} source={query} />, document.getElementById('publications'));
